`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    14:40:31 03/11/2011 
// Design Name: 
// Module Name:    pipeline 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module pipeline(
    input G1_WRCLK0,
    input G1_WRCLK1,
    input G2_WRCLK0,
    input G2_WRCLK1,
    input G3_WRCLK0,
    input G3_WRCLK1,
    input G4_WRCLK0,
    input G4_WRCLK1,
    input G5_WRCLK0,
    input G5_WRCLK1,
    input G6_WRCLK0,
    input G6_WRCLK1,
    input RDCLK,
    input RST,
    input RESTART,
    input [8:0] PDEPTH,
    input [191:0] G1DAQ16CH,
    input [191:0] G2DAQ16CH,
    input [191:0] G3DAQ16CH,
    input [191:0] G4DAQ16CH,
    input [191:0] G5DAQ16CH,
    input [191:0] G6DAQ16CH,
    output reg [191:0] G1PIPOUT,
    output reg [191:0] G2PIPOUT,
    output reg [191:0] G3PIPOUT,
    output reg [191:0] G4PIPOUT,
    output reg [191:0] G5PIPOUT,
    output reg [191:0] G6PIPOUT
    );
	 
	wire g1amt0a,g1amt0b,g1amt0c;
	wire g1amt1a,g1amt1b,g1amt1c;
	wire g2amt0a,g2amt0b,g2amt0c;
	wire g2amt1a,g2amt1b,g2amt1c;
	wire g3amt0a,g3amt0b,g3amt0c;
	wire g3amt1a,g3amt1b,g3amt1c;
	wire g4amt0a,g4amt0b,g4amt0c;
	wire g4amt1a,g4amt1b,g4amt1c;
	wire g5amt0a,g5amt0b,g5amt0c;
	wire g5amt1a,g5amt1b,g5amt1c;
	wire g6amt0a,g6amt0b,g6amt0c;
	wire g6amt1a,g6amt1b,g6amt1c;

	wire g1afl0a,g1afl0b,g1afl0c;
	wire g1afl1a,g1afl1b,g1afl1c;
	wire g2afl0a,g2afl0b,g2afl0c;
	wire g2afl1a,g2afl1b,g2afl1c;
	wire g3afl0a,g3afl0b,g3afl0c;
	wire g3afl1a,g3afl1b,g3afl1c;
	wire g4afl0a,g4afl0b,g4afl0c;
	wire g4afl1a,g4afl1b,g4afl1c;
	wire g5afl0a,g5afl0b,g5afl0c;
	wire g5afl1a,g5afl1b,g5afl1c;
	wire g6afl0a,g6afl0b,g6afl0c;
	wire g6afl1a,g6afl1b,g6afl1c;

	wire g1mt0a,g1mt0b,g1mt0c;
	wire g1mt1a,g1mt1b,g1mt1c;
	wire g2mt0a,g2mt0b,g2mt0c;
	wire g2mt1a,g2mt1b,g2mt1c;
	wire g3mt0a,g3mt0b,g3mt0c;
	wire g3mt1a,g3mt1b,g3mt1c;
	wire g4mt0a,g4mt0b,g4mt0c;
	wire g4mt1a,g4mt1b,g4mt1c;
	wire g5mt0a,g5mt0b,g5mt0c;
	wire g5mt1a,g5mt1b,g5mt1c;
	wire g6mt0a,g6mt0b,g6mt0c;
	wire g6mt1a,g6mt1b,g6mt1c;

	wire g1fl0a,g1fl0b,g1fl0c;
	wire g1fl1a,g1fl1b,g1fl1c;
	wire g2fl0a,g2fl0b,g2fl0c;
	wire g2fl1a,g2fl1b,g2fl1c;
	wire g3fl0a,g3fl0b,g3fl0c;
	wire g3fl1a,g3fl1b,g3fl1c;
	wire g4fl0a,g4fl0b,g4fl0c;
	wire g4fl1a,g4fl1b,g4fl1c;
	wire g5fl0a,g5fl0b,g5fl0c;
	wire g5fl1a,g5fl1b,g5fl1c;
	wire g6fl0a,g6fl0b,g6fl0c;
	wire g6fl1a,g6fl1b,g6fl1c;

	wire [8:0] g1rdcnt0a,g1rdcnt0b,g1rdcnt0c;
	wire [8:0] g1rdcnt1a,g1rdcnt1b,g1rdcnt1c;
	wire [8:0] g2rdcnt0a,g2rdcnt0b,g2rdcnt0c;
	wire [8:0] g2rdcnt1a,g2rdcnt1b,g2rdcnt1c;
	wire [8:0] g3rdcnt0a,g3rdcnt0b,g3rdcnt0c;
	wire [8:0] g3rdcnt1a,g3rdcnt1b,g3rdcnt1c;
	wire [8:0] g4rdcnt0a,g4rdcnt0b,g4rdcnt0c;
	wire [8:0] g4rdcnt1a,g4rdcnt1b,g4rdcnt1c;
	wire [8:0] g5rdcnt0a,g5rdcnt0b,g5rdcnt0c;
	wire [8:0] g5rdcnt1a,g5rdcnt1b,g5rdcnt1c;
	wire [8:0] g6rdcnt0a,g6rdcnt0b,g6rdcnt0c;
	wire [8:0] g6rdcnt1a,g6rdcnt1b,g6rdcnt1c;

	wire g1rderr0a,g1rderr0b,g1rderr0c;
	wire g1rderr1a,g1rderr1b,g1rderr1c;
	wire g2rderr0a,g2rderr0b,g2rderr0c;
	wire g2rderr1a,g2rderr1b,g2rderr1c;
	wire g3rderr0a,g3rderr0b,g3rderr0c;
	wire g3rderr1a,g3rderr1b,g3rderr1c;
	wire g4rderr0a,g4rderr0b,g4rderr0c;
	wire g4rderr1a,g4rderr1b,g4rderr1c;
	wire g5rderr0a,g5rderr0b,g5rderr0c;
	wire g5rderr1a,g5rderr1b,g5rderr1c;
	wire g6rderr0a,g6rderr0b,g6rderr0c;
	wire g6rderr1a,g6rderr1b,g6rderr1c;

	wire [8:0] g1wcnt0a,g1wcnt0b,g1wcnt0c;
	wire [8:0] g1wcnt1a,g1wcnt1b,g1wcnt1c;
	wire [8:0] g2wcnt0a,g2wcnt0b,g2wcnt0c;
	wire [8:0] g2wcnt1a,g2wcnt1b,g2wcnt1c;
	wire [8:0] g3wcnt0a,g3wcnt0b,g3wcnt0c;
	wire [8:0] g3wcnt1a,g3wcnt1b,g3wcnt1c;
	wire [8:0] g4wcnt0a,g4wcnt0b,g4wcnt0c;
	wire [8:0] g4wcnt1a,g4wcnt1b,g4wcnt1c;
	wire [8:0] g5wcnt0a,g5wcnt0b,g5wcnt0c;
	wire [8:0] g5wcnt1a,g5wcnt1b,g5wcnt1c;
	wire [8:0] g6wcnt0a,g6wcnt0b,g6wcnt0c;
	wire [8:0] g6wcnt1a,g6wcnt1b,g6wcnt1c;

	wire g1wrerr0a,g1wrerr0b,g1wrerr0c;
	wire g1wrerr1a,g1wrerr1b,g1wrerr1c;
	wire g2wrerr0a,g2wrerr0b,g2wrerr0c;
	wire g2wrerr1a,g2wrerr1b,g2wrerr1c;
	wire g3wrerr0a,g3wrerr0b,g3wrerr0c;
	wire g3wrerr1a,g3wrerr1b,g3wrerr1c;
	wire g4wrerr0a,g4wrerr0b,g4wrerr0c;
	wire g4wrerr1a,g4wrerr1b,g4wrerr1c;
	wire g5wrerr0a,g5wrerr0b,g5wrerr0c;
	wire g5wrerr1a,g5wrerr1b,g5wrerr1c;
	wire g6wrerr0a,g6wrerr0b,g6wrerr0c;
	wire g6wrerr1a,g6wrerr1b,g6wrerr1c;

	reg  [1:0] g1hold0,g1hold1;
	reg  [1:0] g2hold0,g2hold1;
	reg  [1:0] g3hold0,g3hold1;
	reg  [1:0] g4hold0,g4hold1;
	reg  [1:0] g5hold0,g5hold1;
	reg  [1:0] g6hold0,g6hold1;
	wire g1inc_h0,g1inc_h1;
	wire g2inc_h0,g2inc_h1;
	wire g3inc_h0,g3inc_h1;
	wire g4inc_h0,g4inc_h1;
	wire g5inc_h0,g5inc_h1;
	wire g6inc_h0,g6inc_h1;
	wire g1_pipe_reset0,g1_pipe_reset1;
	wire g2_pipe_reset0,g2_pipe_reset1;
	wire g3_pipe_reset0,g3_pipe_reset1;
	wire g4_pipe_reset0,g4_pipe_reset1;
	wire g5_pipe_reset0,g5_pipe_reset1;
	wire g6_pipe_reset0,g6_pipe_reset1;
	wire g1_re0,g1_re1;
	wire g2_re0,g2_re1;
	wire g3_re0,g3_re1;
	wire g4_re0,g4_re1;
	wire g5_re0,g5_re1;
	wire g6_re0,g6_re1;
   wire g1_we0,g1_we1;
   wire g2_we0,g2_we1;
   wire g3_we0,g3_we1;
   wire g4_we0,g4_we1;
   wire g5_we0,g5_we1;
   wire g6_we0,g6_we1;
	reg re;

   wire  [191:0] g1po,g2po,g3po,g4po,g5po,g6po;


   // FIFO_DUALCLOCK_MACRO: Dual Clock First-In, First-Out (FIFO) RAM Buffer
   //                       Virtex-6
   // Xilinx HDL Language Template, version 12.4
   
   /////////////////////////////////////////////////////////////////
   // DATA_WIDTH | FIFO_SIZE | FIFO Depth | RDCOUNT/WRCOUNT Width //
   // ===========|===========|============|=======================//
   //   37-72    |  "36Kb"   |     512    |         9-bit         //
   //   19-36    |  "36Kb"   |    1024    |        10-bit         //
   //   19-36    |  "18Kb"   |     512    |         9-bit         //
   //   10-18    |  "36Kb"   |    2048    |        11-bit         //
   //   10-18    |  "18Kb"   |    1024    |        10-bit         //
   //    5-9     |  "36Kb"   |    4096    |        12-bit         //
   //    5-9     |  "18Kb"   |    2048    |        11-bit         //
   //    1-4     |  "36Kb"   |    8192    |        13-bit         //
   //    1-4     |  "18Kb"   |    4096    |        12-bit         //
   /////////////////////////////////////////////////////////////////

	
   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G1Pipeline0a (
      .ALMOSTEMPTY(g1amt0a),        // 1-bit output almost empty
      .ALMOSTFULL(g1afl0a),         // 1-bit output almost full
      .DO(g1po[31:0]),              // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g1mt0a),               // 1-bit output empty
      .FULL(g1fl0a),                // 1-bit output full
      .RDCOUNT(g1rdcnt0a),          // Output read count, width determined by FIFO depth
      .RDERR(g1rderr0a),            // 1-bit output read error
      .WRCOUNT(g1wcnt0a),           // Output write count, width determined by FIFO depth
      .WRERR(g1wrerr0a),            // 1-bit output write error
      .DI(G1DAQ16CH[31:0]),         // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g1_pipe_reset0),         // 1-bit input reset
      .WRCLK(G1_WRCLK0),            // 1-bit input clock
      .WREN(g1_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G1Pipeline0b (
      .ALMOSTEMPTY(g1amt0b),        // 1-bit output almost empty
      .ALMOSTFULL(g1afl0b),         // 1-bit output almost full
      .DO(g1po[63:32]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g1mt0b),               // 1-bit output empty
      .FULL(g1fl0b),                // 1-bit output full
      .RDCOUNT(g1rdcnt0b),          // Output read count, width determined by FIFO depth
      .RDERR(g1rderr0b),            // 1-bit output read error
      .WRCOUNT(g1wcnt0b),           // Output write count, width determined by FIFO depth
      .WRERR(g1wrerr0b),            // 1-bit output write error
      .DI(G1DAQ16CH[63:32]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g1_pipe_reset0),         // 1-bit input reset
      .WRCLK(G1_WRCLK0),            // 1-bit input clock
      .WREN(g1_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G1Pipeline0c (
      .ALMOSTEMPTY(g1amt0c),        // 1-bit output almost empty
      .ALMOSTFULL(g1afl0c),         // 1-bit output almost full
      .DO(g1po[95:64]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g1mt0c),               // 1-bit output empty
      .FULL(g1fl0c),                // 1-bit output full
      .RDCOUNT(g1rdcnt0c),          // Output read count, width determined by FIFO depth
      .RDERR(g1rderr0c),            // 1-bit output read error
      .WRCOUNT(g1wcnt0c),           // Output write count, width determined by FIFO depth
      .WRERR(g1wrerr0c),            // 1-bit output write error
      .DI(G1DAQ16CH[95:64]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g1_pipe_reset0),         // 1-bit input reset
      .WRCLK(G1_WRCLK0),            // 1-bit input clock
      .WREN(g1_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G1Pipeline1a (
      .ALMOSTEMPTY(g1amt1a),        // 1-bit output almost empty
      .ALMOSTFULL(g1afl1a),         // 1-bit output almost full
      .DO(g1po[127:96]),            // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g1mt1a),               // 1-bit output empty
      .FULL(g1fl1a),                // 1-bit output full
      .RDCOUNT(g1rdcnt1a),          // Output read count, width determined by FIFO depth
      .RDERR(g1rderr1a),            // 1-bit output read error
      .WRCOUNT(g1wcnt1a),           // Output write count, width determined by FIFO depth
      .WRERR(g1wrerr1a),            // 1-bit output write error
      .DI(G1DAQ16CH[127:96]),       // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g1_pipe_reset1),         // 1-bit input reset
      .WRCLK(G1_WRCLK1),            // 1-bit input clock
      .WREN(g1_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G1Pipeline1b (
      .ALMOSTEMPTY(g1amt1b),        // 1-bit output almost empty
      .ALMOSTFULL(g1afl1b),         // 1-bit output almost full
      .DO(g1po[159:128]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g1mt1b),               // 1-bit output empty
      .FULL(g1fl1b),                // 1-bit output full
      .RDCOUNT(g1rdcnt1b),          // Output read count, width determined by FIFO depth
      .RDERR(g1rderr1b),            // 1-bit output read error
      .WRCOUNT(g1wcnt1b),           // Output write count, width determined by FIFO depth
      .WRERR(g1wrerr1b),            // 1-bit output write error
      .DI(G1DAQ16CH[159:128]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g1_pipe_reset1),         // 1-bit input reset
      .WRCLK(G1_WRCLK1),            // 1-bit input clock
      .WREN(g1_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G1Pipeline1c (
      .ALMOSTEMPTY(g1amt1c),        // 1-bit output almost empty
      .ALMOSTFULL(g1afl1c),         // 1-bit output almost full
      .DO(g1po[191:160]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g1mt1c),               // 1-bit output empty
      .FULL(g1fl1c),                // 1-bit output full
      .RDCOUNT(g1rdcnt1c),          // Output read count, width determined by FIFO depth
      .RDERR(g1rderr1c),            // 1-bit output read error
      .WRCOUNT(g1wcnt1c),           // Output write count, width determined by FIFO depth
      .WRERR(g1wrerr1c),            // 1-bit output write error
      .DI(G1DAQ16CH[191:160]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g1_pipe_reset1),         // 1-bit input reset
      .WRCLK(G1_WRCLK1),            // 1-bit input clock
      .WREN(g1_we1)                 // 1-bit input write enable
   );
	
   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G2Pipeline0a (
      .ALMOSTEMPTY(g2amt0a),        // 1-bit output almost empty
      .ALMOSTFULL(g2afl0a),         // 1-bit output almost full
      .DO(g2po[31:0]),              // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g2mt0a),               // 1-bit output empty
      .FULL(g2fl0a),                // 1-bit output full
      .RDCOUNT(g2rdcnt0a),          // Output read count, width determined by FIFO depth
      .RDERR(g2rderr0a),            // 1-bit output read error
      .WRCOUNT(g2wcnt0a),           // Output write count, width determined by FIFO depth
      .WRERR(g2wrerr0a),            // 1-bit output write error
      .DI(G2DAQ16CH[31:0]),         // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g2_pipe_reset0),         // 1-bit input reset
      .WRCLK(G2_WRCLK0),            // 1-bit input clock
      .WREN(g2_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G2Pipeline0b (
      .ALMOSTEMPTY(g2amt0b),        // 1-bit output almost empty
      .ALMOSTFULL(g2afl0b),         // 1-bit output almost full
      .DO(g2po[63:32]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g2mt0b),               // 1-bit output empty
      .FULL(g2fl0b),                // 1-bit output full
      .RDCOUNT(g2rdcnt0b),          // Output read count, width determined by FIFO depth
      .RDERR(g2rderr0b),            // 1-bit output read error
      .WRCOUNT(g2wcnt0b),           // Output write count, width determined by FIFO depth
      .WRERR(g2wrerr0b),            // 1-bit output write error
      .DI(G2DAQ16CH[63:32]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g2_pipe_reset0),         // 1-bit input reset
      .WRCLK(G2_WRCLK0),            // 1-bit input clock
      .WREN(g2_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G2Pipeline0c (
      .ALMOSTEMPTY(g2amt0c),        // 1-bit output almost empty
      .ALMOSTFULL(g2afl0c),         // 1-bit output almost full
      .DO(g2po[95:64]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g2mt0c),               // 1-bit output empty
      .FULL(g2fl0c),                // 1-bit output full
      .RDCOUNT(g2rdcnt0c),          // Output read count, width determined by FIFO depth
      .RDERR(g2rderr0c),            // 1-bit output read error
      .WRCOUNT(g2wcnt0c),           // Output write count, width determined by FIFO depth
      .WRERR(g2wrerr0c),            // 1-bit output write error
      .DI(G2DAQ16CH[95:64]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g2_pipe_reset0),         // 1-bit input reset
      .WRCLK(G2_WRCLK0),            // 1-bit input clock
      .WREN(g2_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G2Pipeline1a (
      .ALMOSTEMPTY(g2amt1a),        // 1-bit output almost empty
      .ALMOSTFULL(g2afl1a),         // 1-bit output almost full
      .DO(g2po[127:96]),            // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g2mt1a),               // 1-bit output empty
      .FULL(g2fl1a),                // 1-bit output full
      .RDCOUNT(g2rdcnt1a),          // Output read count, width determined by FIFO depth
      .RDERR(g2rderr1a),            // 1-bit output read error
      .WRCOUNT(g2wcnt1a),           // Output write count, width determined by FIFO depth
      .WRERR(g2wrerr1a),            // 1-bit output write error
      .DI(G2DAQ16CH[127:96]),       // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g2_pipe_reset1),         // 1-bit input reset
      .WRCLK(G2_WRCLK1),            // 1-bit input clock
      .WREN(g2_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G2Pipeline1b (
      .ALMOSTEMPTY(g2amt1b),        // 1-bit output almost empty
      .ALMOSTFULL(g2afl1b),         // 1-bit output almost full
      .DO(g2po[159:128]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g2mt1b),               // 1-bit output empty
      .FULL(g2fl1b),                // 1-bit output full
      .RDCOUNT(g2rdcnt1b),          // Output read count, width determined by FIFO depth
      .RDERR(g2rderr1b),            // 1-bit output read error
      .WRCOUNT(g2wcnt1b),           // Output write count, width determined by FIFO depth
      .WRERR(g2wrerr1b),            // 1-bit output write error
      .DI(G2DAQ16CH[159:128]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g2_pipe_reset1),         // 1-bit input reset
      .WRCLK(G2_WRCLK1),            // 1-bit input clock
      .WREN(g2_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G2Pipeline1c (
      .ALMOSTEMPTY(g2amt1c),        // 1-bit output almost empty
      .ALMOSTFULL(g2afl1c),         // 1-bit output almost full
      .DO(g2po[191:160]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g2mt1c),               // 1-bit output empty
      .FULL(g2fl1c),                // 1-bit output full
      .RDCOUNT(g2rdcnt1c),          // Output read count, width determined by FIFO depth
      .RDERR(g2rderr1c),            // 1-bit output read error
      .WRCOUNT(g2wcnt1c),           // Output write count, width determined by FIFO depth
      .WRERR(g2wrerr1c),            // 1-bit output write error
      .DI(G2DAQ16CH[191:160]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g2_pipe_reset1),         // 1-bit input reset
      .WRCLK(G2_WRCLK1),            // 1-bit input clock
      .WREN(g2_we1)                 // 1-bit input write enable
   );
	
   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G3Pipeline0a (
      .ALMOSTEMPTY(g3amt0a),        // 1-bit output almost empty
      .ALMOSTFULL(g3afl0a),         // 1-bit output almost full
      .DO(g3po[31:0]),              // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g3mt0a),               // 1-bit output empty
      .FULL(g3fl0a),                // 1-bit output full
      .RDCOUNT(g3rdcnt0a),          // Output read count, width determined by FIFO depth
      .RDERR(g3rderr0a),            // 1-bit output read error
      .WRCOUNT(g3wcnt0a),           // Output write count, width determined by FIFO depth
      .WRERR(g3wrerr0a),            // 1-bit output write error
      .DI(G3DAQ16CH[31:0]),         // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g3_pipe_reset0),         // 1-bit input reset
      .WRCLK(G3_WRCLK0),            // 1-bit input clock
      .WREN(g3_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G3Pipeline0b (
      .ALMOSTEMPTY(g3amt0b),        // 1-bit output almost empty
      .ALMOSTFULL(g3afl0b),         // 1-bit output almost full
      .DO(g3po[63:32]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g3mt0b),               // 1-bit output empty
      .FULL(g3fl0b),                // 1-bit output full
      .RDCOUNT(g3rdcnt0b),          // Output read count, width determined by FIFO depth
      .RDERR(g3rderr0b),            // 1-bit output read error
      .WRCOUNT(g3wcnt0b),           // Output write count, width determined by FIFO depth
      .WRERR(g3wrerr0b),            // 1-bit output write error
      .DI(G3DAQ16CH[63:32]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g3_pipe_reset0),         // 1-bit input reset
      .WRCLK(G3_WRCLK0),            // 1-bit input clock
      .WREN(g3_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G3Pipeline0c (
      .ALMOSTEMPTY(g3amt0c),        // 1-bit output almost empty
      .ALMOSTFULL(g3afl0c),         // 1-bit output almost full
      .DO(g3po[95:64]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g3mt0c),               // 1-bit output empty
      .FULL(g3fl0c),                // 1-bit output full
      .RDCOUNT(g3rdcnt0c),          // Output read count, width determined by FIFO depth
      .RDERR(g3rderr0c),            // 1-bit output read error
      .WRCOUNT(g3wcnt0c),           // Output write count, width determined by FIFO depth
      .WRERR(g3wrerr0c),            // 1-bit output write error
      .DI(G3DAQ16CH[95:64]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g3_pipe_reset0),         // 1-bit input reset
      .WRCLK(G3_WRCLK0),            // 1-bit input clock
      .WREN(g3_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G3Pipeline1a (
      .ALMOSTEMPTY(g3amt1a),        // 1-bit output almost empty
      .ALMOSTFULL(g3afl1a),         // 1-bit output almost full
      .DO(g3po[127:96]),            // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g3mt1a),               // 1-bit output empty
      .FULL(g3fl1a),                // 1-bit output full
      .RDCOUNT(g3rdcnt1a),          // Output read count, width determined by FIFO depth
      .RDERR(g3rderr1a),            // 1-bit output read error
      .WRCOUNT(g3wcnt1a),           // Output write count, width determined by FIFO depth
      .WRERR(g3wrerr1a),            // 1-bit output write error
      .DI(G3DAQ16CH[127:96]),       // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g3_pipe_reset1),         // 1-bit input reset
      .WRCLK(G3_WRCLK1),            // 1-bit input clock
      .WREN(g3_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G3Pipeline1b (
      .ALMOSTEMPTY(g3amt1b),        // 1-bit output almost empty
      .ALMOSTFULL(g3afl1b),         // 1-bit output almost full
      .DO(g3po[159:128]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g3mt1b),               // 1-bit output empty
      .FULL(g3fl1b),                // 1-bit output full
      .RDCOUNT(g3rdcnt1b),          // Output read count, width determined by FIFO depth
      .RDERR(g3rderr1b),            // 1-bit output read error
      .WRCOUNT(g3wcnt1b),           // Output write count, width determined by FIFO depth
      .WRERR(g3wrerr1b),            // 1-bit output write error
      .DI(G3DAQ16CH[159:128]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g3_pipe_reset1),         // 1-bit input reset
      .WRCLK(G3_WRCLK1),            // 1-bit input clock
      .WREN(g3_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G3Pipeline1c (
      .ALMOSTEMPTY(g3amt1c),        // 1-bit output almost empty
      .ALMOSTFULL(g3afl1c),         // 1-bit output almost full
      .DO(g3po[191:160]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g3mt1c),               // 1-bit output empty
      .FULL(g3fl1c),                // 1-bit output full
      .RDCOUNT(g3rdcnt1c),          // Output read count, width determined by FIFO depth
      .RDERR(g3rderr1c),            // 1-bit output read error
      .WRCOUNT(g3wcnt1c),           // Output write count, width determined by FIFO depth
      .WRERR(g3wrerr1c),            // 1-bit output write error
      .DI(G3DAQ16CH[191:160]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g3_pipe_reset1),         // 1-bit input reset
      .WRCLK(G3_WRCLK1),            // 1-bit input clock
      .WREN(g3_we1)                 // 1-bit input write enable
   );
	
   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G4Pipeline0a (
      .ALMOSTEMPTY(g4amt0a),        // 1-bit output almost empty
      .ALMOSTFULL(g4afl0a),         // 1-bit output almost full
      .DO(g4po[31:0]),              // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g4mt0a),               // 1-bit output empty
      .FULL(g4fl0a),                // 1-bit output full
      .RDCOUNT(g4rdcnt0a),          // Output read count, width determined by FIFO depth
      .RDERR(g4rderr0a),            // 1-bit output read error
      .WRCOUNT(g4wcnt0a),           // Output write count, width determined by FIFO depth
      .WRERR(g4wrerr0a),            // 1-bit output write error
      .DI(G4DAQ16CH[31:0]),         // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g4_pipe_reset0),         // 1-bit input reset
      .WRCLK(G4_WRCLK0),            // 1-bit input clock
      .WREN(g4_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G4Pipeline0b (
      .ALMOSTEMPTY(g4amt0b),        // 1-bit output almost empty
      .ALMOSTFULL(g4afl0b),         // 1-bit output almost full
      .DO(g4po[63:32]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g4mt0b),               // 1-bit output empty
      .FULL(g4fl0b),                // 1-bit output full
      .RDCOUNT(g4rdcnt0b),          // Output read count, width determined by FIFO depth
      .RDERR(g4rderr0b),            // 1-bit output read error
      .WRCOUNT(g4wcnt0b),           // Output write count, width determined by FIFO depth
      .WRERR(g4wrerr0b),            // 1-bit output write error
      .DI(G4DAQ16CH[63:32]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g4_pipe_reset0),         // 1-bit input reset
      .WRCLK(G4_WRCLK0),            // 1-bit input clock
      .WREN(g4_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G4Pipeline0c (
      .ALMOSTEMPTY(g4amt0c),        // 1-bit output almost empty
      .ALMOSTFULL(g4afl0c),         // 1-bit output almost full
      .DO(g4po[95:64]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g4mt0c),               // 1-bit output empty
      .FULL(g4fl0c),                // 1-bit output full
      .RDCOUNT(g4rdcnt0c),          // Output read count, width determined by FIFO depth
      .RDERR(g4rderr0c),            // 1-bit output read error
      .WRCOUNT(g4wcnt0c),           // Output write count, width determined by FIFO depth
      .WRERR(g4wrerr0c),            // 1-bit output write error
      .DI(G4DAQ16CH[95:64]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g4_pipe_reset0),         // 1-bit input reset
      .WRCLK(G4_WRCLK0),            // 1-bit input clock
      .WREN(g4_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G4Pipeline1a (
      .ALMOSTEMPTY(g4amt1a),        // 1-bit output almost empty
      .ALMOSTFULL(g4afl1a),         // 1-bit output almost full
      .DO(g4po[127:96]),            // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g4mt1a),               // 1-bit output empty
      .FULL(g4fl1a),                // 1-bit output full
      .RDCOUNT(g4rdcnt1a),          // Output read count, width determined by FIFO depth
      .RDERR(g4rderr1a),            // 1-bit output read error
      .WRCOUNT(g4wcnt1a),           // Output write count, width determined by FIFO depth
      .WRERR(g4wrerr1a),            // 1-bit output write error
      .DI(G4DAQ16CH[127:96]),       // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g4_pipe_reset1),         // 1-bit input reset
      .WRCLK(G4_WRCLK1),            // 1-bit input clock
      .WREN(g4_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G4Pipeline1b (
      .ALMOSTEMPTY(g4amt1b),        // 1-bit output almost empty
      .ALMOSTFULL(g4afl1b),         // 1-bit output almost full
      .DO(g4po[159:128]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g4mt1b),               // 1-bit output empty
      .FULL(g4fl1b),                // 1-bit output full
      .RDCOUNT(g4rdcnt1b),          // Output read count, width determined by FIFO depth
      .RDERR(g4rderr1b),            // 1-bit output read error
      .WRCOUNT(g4wcnt1b),           // Output write count, width determined by FIFO depth
      .WRERR(g4wrerr1b),            // 1-bit output write error
      .DI(G4DAQ16CH[159:128]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g4_pipe_reset1),         // 1-bit input reset
      .WRCLK(G4_WRCLK1),            // 1-bit input clock
      .WREN(g4_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G4Pipeline1c (
      .ALMOSTEMPTY(g4amt1c),        // 1-bit output almost empty
      .ALMOSTFULL(g4afl1c),         // 1-bit output almost full
      .DO(g4po[191:160]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g4mt1c),               // 1-bit output empty
      .FULL(g4fl1c),                // 1-bit output full
      .RDCOUNT(g4rdcnt1c),          // Output read count, width determined by FIFO depth
      .RDERR(g4rderr1c),            // 1-bit output read error
      .WRCOUNT(g4wcnt1c),           // Output write count, width determined by FIFO depth
      .WRERR(g4wrerr1c),            // 1-bit output write error
      .DI(G4DAQ16CH[191:160]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g4_pipe_reset1),         // 1-bit input reset
      .WRCLK(G4_WRCLK1),            // 1-bit input clock
      .WREN(g4_we1)                 // 1-bit input write enable
   );
	
   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G5Pipeline0a (
      .ALMOSTEMPTY(g5amt0a),        // 1-bit output almost empty
      .ALMOSTFULL(g5afl0a),         // 1-bit output almost full
      .DO(g5po[31:0]),              // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g5mt0a),               // 1-bit output empty
      .FULL(g5fl0a),                // 1-bit output full
      .RDCOUNT(g5rdcnt0a),          // Output read count, width determined by FIFO depth
      .RDERR(g5rderr0a),            // 1-bit output read error
      .WRCOUNT(g5wcnt0a),           // Output write count, width determined by FIFO depth
      .WRERR(g5wrerr0a),            // 1-bit output write error
      .DI(G5DAQ16CH[31:0]),         // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g5_pipe_reset0),         // 1-bit input reset
      .WRCLK(G5_WRCLK0),            // 1-bit input clock
      .WREN(g5_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G5Pipeline0b (
      .ALMOSTEMPTY(g5amt0b),        // 1-bit output almost empty
      .ALMOSTFULL(g5afl0b),         // 1-bit output almost full
      .DO(g5po[63:32]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g5mt0b),               // 1-bit output empty
      .FULL(g5fl0b),                // 1-bit output full
      .RDCOUNT(g5rdcnt0b),          // Output read count, width determined by FIFO depth
      .RDERR(g5rderr0b),            // 1-bit output read error
      .WRCOUNT(g5wcnt0b),           // Output write count, width determined by FIFO depth
      .WRERR(g5wrerr0b),            // 1-bit output write error
      .DI(G5DAQ16CH[63:32]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g5_pipe_reset0),         // 1-bit input reset
      .WRCLK(G5_WRCLK0),            // 1-bit input clock
      .WREN(g5_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G5Pipeline0c (
      .ALMOSTEMPTY(g5amt0c),        // 1-bit output almost empty
      .ALMOSTFULL(g5afl0c),         // 1-bit output almost full
      .DO(g5po[95:64]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g5mt0c),               // 1-bit output empty
      .FULL(g5fl0c),                // 1-bit output full
      .RDCOUNT(g5rdcnt0c),          // Output read count, width determined by FIFO depth
      .RDERR(g5rderr0c),            // 1-bit output read error
      .WRCOUNT(g5wcnt0c),           // Output write count, width determined by FIFO depth
      .WRERR(g5wrerr0c),            // 1-bit output write error
      .DI(G5DAQ16CH[95:64]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g5_pipe_reset0),         // 1-bit input reset
      .WRCLK(G5_WRCLK0),            // 1-bit input clock
      .WREN(g5_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G5Pipeline1a (
      .ALMOSTEMPTY(g5amt1a),        // 1-bit output almost empty
      .ALMOSTFULL(g5afl1a),         // 1-bit output almost full
      .DO(g5po[127:96]),            // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g5mt1a),               // 1-bit output empty
      .FULL(g5fl1a),                // 1-bit output full
      .RDCOUNT(g5rdcnt1a),          // Output read count, width determined by FIFO depth
      .RDERR(g5rderr1a),            // 1-bit output read error
      .WRCOUNT(g5wcnt1a),           // Output write count, width determined by FIFO depth
      .WRERR(g5wrerr1a),            // 1-bit output write error
      .DI(G5DAQ16CH[127:96]),       // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g5_pipe_reset1),         // 1-bit input reset
      .WRCLK(G5_WRCLK1),            // 1-bit input clock
      .WREN(g5_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G5Pipeline1b (
      .ALMOSTEMPTY(g5amt1b),        // 1-bit output almost empty
      .ALMOSTFULL(g5afl1b),         // 1-bit output almost full
      .DO(g5po[159:128]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g5mt1b),               // 1-bit output empty
      .FULL(g5fl1b),                // 1-bit output full
      .RDCOUNT(g5rdcnt1b),          // Output read count, width determined by FIFO depth
      .RDERR(g5rderr1b),            // 1-bit output read error
      .WRCOUNT(g5wcnt1b),           // Output write count, width determined by FIFO depth
      .WRERR(g5wrerr1b),            // 1-bit output write error
      .DI(G5DAQ16CH[159:128]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g5_pipe_reset1),         // 1-bit input reset
      .WRCLK(G5_WRCLK1),            // 1-bit input clock
      .WREN(g5_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G5Pipeline1c (
      .ALMOSTEMPTY(g5amt1c),        // 1-bit output almost empty
      .ALMOSTFULL(g5afl1c),         // 1-bit output almost full
      .DO(g5po[191:160]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g5mt1c),               // 1-bit output empty
      .FULL(g5fl1c),                // 1-bit output full
      .RDCOUNT(g5rdcnt1c),          // Output read count, width determined by FIFO depth
      .RDERR(g5rderr1c),            // 1-bit output read error
      .WRCOUNT(g5wcnt1c),           // Output write count, width determined by FIFO depth
      .WRERR(g5wrerr1c),            // 1-bit output write error
      .DI(G5DAQ16CH[191:160]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g5_pipe_reset1),         // 1-bit input reset
      .WRCLK(G5_WRCLK1),            // 1-bit input clock
      .WREN(g5_we1)                 // 1-bit input write enable
   );
	
   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G6Pipeline0a (
      .ALMOSTEMPTY(g6amt0a),        // 1-bit output almost empty
      .ALMOSTFULL(g6afl0a),         // 1-bit output almost full
      .DO(g6po[31:0]),              // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g6mt0a),               // 1-bit output empty
      .FULL(g6fl0a),                // 1-bit output full
      .RDCOUNT(g6rdcnt0a),          // Output read count, width determined by FIFO depth
      .RDERR(g6rderr0a),            // 1-bit output read error
      .WRCOUNT(g6wcnt0a),           // Output write count, width determined by FIFO depth
      .WRERR(g6wrerr0a),            // 1-bit output write error
      .DI(G6DAQ16CH[31:0]),         // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g6_pipe_reset0),         // 1-bit input reset
      .WRCLK(G6_WRCLK0),            // 1-bit input clock
      .WREN(g6_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G6Pipeline0b (
      .ALMOSTEMPTY(g6amt0b),        // 1-bit output almost empty
      .ALMOSTFULL(g6afl0b),         // 1-bit output almost full
      .DO(g6po[63:32]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g6mt0b),               // 1-bit output empty
      .FULL(g6fl0b),                // 1-bit output full
      .RDCOUNT(g6rdcnt0b),          // Output read count, width determined by FIFO depth
      .RDERR(g6rderr0b),            // 1-bit output read error
      .WRCOUNT(g6wcnt0b),           // Output write count, width determined by FIFO depth
      .WRERR(g6wrerr0b),            // 1-bit output write error
      .DI(G6DAQ16CH[63:32]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g6_pipe_reset0),         // 1-bit input reset
      .WRCLK(G6_WRCLK0),            // 1-bit input clock
      .WREN(g6_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G6Pipeline0c (
      .ALMOSTEMPTY(g6amt0c),        // 1-bit output almost empty
      .ALMOSTFULL(g6afl0c),         // 1-bit output almost full
      .DO(g6po[95:64]),             // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g6mt0c),               // 1-bit output empty
      .FULL(g6fl0c),                // 1-bit output full
      .RDCOUNT(g6rdcnt0c),          // Output read count, width determined by FIFO depth
      .RDERR(g6rderr0c),            // 1-bit output read error
      .WRCOUNT(g6wcnt0c),           // Output write count, width determined by FIFO depth
      .WRERR(g6wrerr0c),            // 1-bit output write error
      .DI(G6DAQ16CH[95:64]),        // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g6_pipe_reset0),         // 1-bit input reset
      .WRCLK(G6_WRCLK0),            // 1-bit input clock
      .WREN(g6_we0)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G6Pipeline1a (
      .ALMOSTEMPTY(g6amt1a),        // 1-bit output almost empty
      .ALMOSTFULL(g6afl1a),         // 1-bit output almost full
      .DO(g6po[127:96]),            // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g6mt1a),               // 1-bit output empty
      .FULL(g6fl1a),                // 1-bit output full
      .RDCOUNT(g6rdcnt1a),          // Output read count, width determined by FIFO depth
      .RDERR(g6rderr1a),            // 1-bit output read error
      .WRCOUNT(g6wcnt1a),           // Output write count, width determined by FIFO depth
      .WRERR(g6wrerr1a),            // 1-bit output write error
      .DI(G6DAQ16CH[127:96]),       // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g6_pipe_reset1),         // 1-bit input reset
      .WRCLK(G6_WRCLK1),            // 1-bit input clock
      .WREN(g6_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G6Pipeline1b (
      .ALMOSTEMPTY(g6amt1b),        // 1-bit output almost empty
      .ALMOSTFULL(g6afl1b),         // 1-bit output almost full
      .DO(g6po[159:128]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g6mt1b),               // 1-bit output empty
      .FULL(g6fl1b),                // 1-bit output full
      .RDCOUNT(g6rdcnt1b),          // Output read count, width determined by FIFO depth
      .RDERR(g6rderr1b),            // 1-bit output read error
      .WRCOUNT(g6wcnt1b),           // Output write count, width determined by FIFO depth
      .WRERR(g6wrerr1b),            // 1-bit output write error
      .DI(G6DAQ16CH[159:128]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g6_pipe_reset1),         // 1-bit input reset
      .WRCLK(G6_WRCLK1),            // 1-bit input clock
      .WREN(g6_we1)                 // 1-bit input write enable
   );

   FIFO_DUALCLOCK_MACRO  #(
      .DEVICE("VIRTEX6"),           // Target Device: "VIRTEX5", "VIRTEX6" 
      .ALMOST_EMPTY_OFFSET(9'h080), // Sets the almost empty threshold
      .ALMOST_FULL_OFFSET(9'h080),  // Sets almost full threshold
      .DATA_WIDTH(32),              // Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      .FIFO_SIZE ("18Kb"),          // Target BRAM: "18Kb" or "36Kb" 
      .FIRST_WORD_FALL_THROUGH ("FALSE") // Sets the FIFO FWFT to "TRUE" or "FALSE" 
   ) G6Pipeline1c (
      .ALMOSTEMPTY(g6amt1c),        // 1-bit output almost empty
      .ALMOSTFULL(g6afl1c),         // 1-bit output almost full
      .DO(g6po[191:160]),           // Output data, width defined by DATA_WIDTH parameter
      .EMPTY(g6mt1c),               // 1-bit output empty
      .FULL(g6fl1c),                // 1-bit output full
      .RDCOUNT(g6rdcnt1c),          // Output read count, width determined by FIFO depth
      .RDERR(g6rderr1c),            // 1-bit output read error
      .WRCOUNT(g6wcnt1c),           // Output write count, width determined by FIFO depth
      .WRERR(g6wrerr1c),            // 1-bit output write error
      .DI(G6DAQ16CH[191:160]),      // Input data, width defined by DATA_WIDTH parameter
      .RDCLK(RDCLK),                // 1-bit input read clock
      .RDEN(re),                    // 1-bit input read enable
      .RST(g6_pipe_reset1),         // 1-bit input reset
      .WRCLK(G6_WRCLK1),            // 1-bit input clock
      .WREN(g6_we1)                 // 1-bit input write enable
   );
	
	
	
	
always @(posedge RDCLK) begin
   G1PIPOUT <= g1po;
	G2PIPOUT <= g2po;
	G3PIPOUT <= g3po;
	G4PIPOUT <= g4po;
	G5PIPOUT <= g5po;
	G6PIPOUT <= g6po;
	re <= g1_re0 | g1_re1 | g2_re0 | g2_re1 | g3_re0 | g3_re1 | g4_re0 | g4_re1 | g5_re0 | g5_re1 | g6_re0 | g6_re1;
end

Pipe_Start_FSM 
G1Pipe_Start_FSM0 (
  .INC_H(g1inc_h0),         // Increment Hold counter
  .PIP_RST(g1_pipe_reset0), // Reset for pipeline
  .RE(g1_re0),              // Read enable
  .WE(g1_we0),              // Write enable
  .CLK(G1_WRCLK0),          // Clock
  .HOLD(g1hold0),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g1wcnt0a)           // Write count from pipeline
);
Pipe_Start_FSM 
G1Pipe_Start_FSM1 (
  .INC_H(g1inc_h1),         // Increment Hold counter
  .PIP_RST(g1_pipe_reset1), // Reset for pipeline
  .RE(g1_re1),              // Read enable
  .WE(g1_we1),              // Write enable
  .CLK(G1_WRCLK1),          // Clock
  .HOLD(g1hold1),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g1wcnt1a)           // Write count from pipeline
);

Pipe_Start_FSM 
G2Pipe_Start_FSM0 (
  .INC_H(g2inc_h0),         // Increment Hold counter
  .PIP_RST(g2_pipe_reset0), // Reset for pipeline
  .RE(g2_re0),              // Read enable
  .WE(g2_we0),              // Write enable
  .CLK(G2_WRCLK0),          // Clock
  .HOLD(g2hold0),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g2wcnt0a)           // Write count from pipeline
);
Pipe_Start_FSM 
G2Pipe_Start_FSM1 (
  .INC_H(g2inc_h1),         // Increment Hold counter
  .PIP_RST(g2_pipe_reset1), // Reset for pipeline
  .RE(g2_re1),              // Read enable
  .WE(g2_we1),              // Write enable
  .CLK(G2_WRCLK1),          // Clock
  .HOLD(g2hold1),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g2wcnt1a)           // Write count from pipeline
);

Pipe_Start_FSM 
G3Pipe_Start_FSM0 (
  .INC_H(g3inc_h0),         // Increment Hold counter
  .PIP_RST(g3_pipe_reset0), // Reset for pipeline
  .RE(g3_re0),              // Read enable
  .WE(g3_we0),              // Write enable
  .CLK(G3_WRCLK0),          // Clock
  .HOLD(g3hold0),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g3wcnt0a)           // Write count from pipeline
);
Pipe_Start_FSM 
G3Pipe_Start_FSM1 (
  .INC_H(g3inc_h1),         // Increment Hold counter
  .PIP_RST(g3_pipe_reset1), // Reset for pipeline
  .RE(g3_re1),              // Read enable
  .WE(g3_we1),              // Write enable
  .CLK(G3_WRCLK1),          // Clock
  .HOLD(g3hold1),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g3wcnt1a)           // Write count from pipeline
);

Pipe_Start_FSM 
G4Pipe_Start_FSM0 (
  .INC_H(g4inc_h0),         // Increment Hold counter
  .PIP_RST(g4_pipe_reset0), // Reset for pipeline
  .RE(g4_re0),              // Read enable
  .WE(g4_we0),              // Write enable
  .CLK(G4_WRCLK0),          // Clock
  .HOLD(g4hold0),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g4wcnt0a)           // Write count from pipeline
);
Pipe_Start_FSM 
G4Pipe_Start_FSM1 (
  .INC_H(g4inc_h1),         // Increment Hold counter
  .PIP_RST(g4_pipe_reset1), // Reset for pipeline
  .RE(g4_re1),              // Read enable
  .WE(g4_we1),              // Write enable
  .CLK(G4_WRCLK1),          // Clock
  .HOLD(g4hold1),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g4wcnt1a)           // Write count from pipeline
);

Pipe_Start_FSM 
G5Pipe_Start_FSM0 (
  .INC_H(g5inc_h0),         // Increment Hold counter
  .PIP_RST(g5_pipe_reset0), // Reset for pipeline
  .RE(g5_re0),              // Read enable
  .WE(g5_we0),              // Write enable
  .CLK(G5_WRCLK0),          // Clock
  .HOLD(g5hold0),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g5wcnt0a)           // Write count from pipeline
);
Pipe_Start_FSM 
G5Pipe_Start_FSM1 (
  .INC_H(g5inc_h1),         // Increment Hold counter
  .PIP_RST(g5_pipe_reset1), // Reset for pipeline
  .RE(g5_re1),              // Read enable
  .WE(g5_we1),              // Write enable
  .CLK(G5_WRCLK1),          // Clock
  .HOLD(g5hold1),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g5wcnt1a)           // Write count from pipeline
);

Pipe_Start_FSM 
G6Pipe_Start_FSM0 (
  .INC_H(g6inc_h0),         // Increment Hold counter
  .PIP_RST(g6_pipe_reset0), // Reset for pipeline
  .RE(g6_re0),              // Read enable
  .WE(g6_we0),              // Write enable
  .CLK(G6_WRCLK0),          // Clock
  .HOLD(g6hold0),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g6wcnt0a)           // Write count from pipeline
);
Pipe_Start_FSM 
G6Pipe_Start_FSM1 (
  .INC_H(g6inc_h1),         // Increment Hold counter
  .PIP_RST(g6_pipe_reset1), // Reset for pipeline
  .RE(g6_re1),              // Read enable
  .WE(g6_we1),              // Write enable
  .CLK(G6_WRCLK1),          // Clock
  .HOLD(g6hold1),           // 2 bit Hold counter
  .PDEPTH(PDEPTH),          // Pipeline depth from JTAG register
  .RESTART(RESTART),        // Restart pipeline signal from JTAG command
  .RST(RST),                // Reset
  .WCNT(g6wcnt1a)           // Write count from pipeline
);


always @(posedge G1_WRCLK0 or posedge RST) begin
   if(RST)
	   g1hold0 <= 2'b00;
	else
	   if(g1inc_h0)
		   g1hold0 <= g1hold0 + 1;
		else
		   g1hold0 <= g1hold0;
end
always @(posedge G1_WRCLK1 or posedge RST) begin
   if(RST)
	   g1hold1 <= 2'b00;
	else
	   if(g1inc_h1)
		   g1hold1 <= g1hold1 + 1;
		else
		   g1hold1 <= g1hold1;
end

always @(posedge G2_WRCLK0 or posedge RST) begin
   if(RST)
	   g2hold0 <= 2'b00;
	else
	   if(g2inc_h0)
		   g2hold0 <= g2hold0 + 1;
		else
		   g2hold0 <= g2hold0;
end
always @(posedge G2_WRCLK1 or posedge RST) begin
   if(RST)
	   g2hold1 <= 2'b00;
	else
	   if(g2inc_h1)
		   g2hold1 <= g2hold1 + 1;
		else
		   g2hold1 <= g2hold1;
end

always @(posedge G3_WRCLK0 or posedge RST) begin
   if(RST)
	   g3hold0 <= 2'b00;
	else
	   if(g3inc_h0)
		   g3hold0 <= g3hold0 + 1;
		else
		   g3hold0 <= g3hold0;
end
always @(posedge G3_WRCLK1 or posedge RST) begin
   if(RST)
	   g3hold1 <= 2'b00;
	else
	   if(g3inc_h1)
		   g3hold1 <= g3hold1 + 1;
		else
		   g3hold1 <= g3hold1;
end

always @(posedge G4_WRCLK0 or posedge RST) begin
   if(RST)
	   g4hold0 <= 2'b00;
	else
	   if(g4inc_h0)
		   g4hold0 <= g4hold0 + 1;
		else
		   g4hold0 <= g4hold0;
end
always @(posedge G4_WRCLK1 or posedge RST) begin
   if(RST)
	   g4hold1 <= 2'b00;
	else
	   if(g4inc_h1)
		   g4hold1 <= g4hold1 + 1;
		else
		   g4hold1 <= g4hold1;
end

always @(posedge G5_WRCLK0 or posedge RST) begin
   if(RST)
	   g5hold0 <= 2'b00;
	else
	   if(g5inc_h0)
		   g5hold0 <= g5hold0 + 1;
		else
		   g5hold0 <= g5hold0;
end
always @(posedge G5_WRCLK1 or posedge RST) begin
   if(RST)
	   g5hold1 <= 2'b00;
	else
	   if(g5inc_h1)
		   g5hold1 <= g5hold1 + 1;
		else
		   g5hold1 <= g5hold1;
end

always @(posedge G6_WRCLK0 or posedge RST) begin
   if(RST)
	   g6hold0 <= 2'b00;
	else
	   if(g6inc_h0)
		   g6hold0 <= g6hold0 + 1;
		else
		   g6hold0 <= g6hold0;
end
always @(posedge G6_WRCLK1 or posedge RST) begin
   if(RST)
	   g6hold1 <= 2'b00;
	else
	   if(g6inc_h1)
		   g6hold1 <= g6hold1 + 1;
		else
		   g6hold1 <= g6hold1;
end


endmodule


// Created by fizzim.pl version 3.60 on 2011:03:11 at 14:09:45 (www.fizzim.com)

module Pipe_Start_FSM (
  output reg INC_H,
  output reg PIP_RST,
  output reg RE,
  output reg WE,
  input CLK,
  input wire [1:0] HOLD,
  input wire [8:0] PDEPTH,
  input RESTART,
  input RST,
  input wire [8:0] WCNT 
);
  
  // state bits
  parameter 
  Idle       = 3'b000, 
  Clear      = 3'b001, 
  Reset_Pipe = 3'b010, 
  Run        = 3'b011, 
  Start_Pipe = 3'b100; 
  
  reg [2:0] state;
  reg [2:0] nextstate;
  
  // comb always block
  always @* begin
    nextstate = 3'bx; // default to x because default_state_is_x is set
    INC_H = 0; // default
    PIP_RST = 0; // default
    RE = 0; // default
    WE = 0; // default
    case (state)
      Idle      :            nextstate = Clear;
      Clear     : begin
                             INC_H = 1;
        if (HOLD == 2'd3)    nextstate = Reset_Pipe;
        else                 nextstate = Clear;
      end
      Reset_Pipe: begin
                             INC_H = 1;
                             PIP_RST = 1;
        if (HOLD == 2'd3)    nextstate = Start_Pipe;
        else                 nextstate = Reset_Pipe;
      end
      Run       : begin
                             RE = 1;
                             WE = 1;
        if (RESTART)         nextstate = Idle;
        else                 nextstate = Run;
      end
      Start_Pipe: begin
                             WE = 1;
        if (WCNT == PDEPTH)  nextstate = Run;
        else                 nextstate = Start_Pipe;
      end
    endcase
  end
  
  // Assign reg'd outputs to state bits
  
  // sequential always block
  always @(posedge CLK or posedge RST) begin
    if (RST)
      state <= Idle;
    else
      state <= nextstate;
  end
  
  // This code allows you to see state names in simulation
  `ifndef SYNTHESIS
  reg [79:0] statename;
  always @* begin
    case (state)
      Idle      : statename = "Idle";
      Clear     : statename = "Clear";
      Reset_Pipe: statename = "Reset_Pipe";
      Run       : statename = "Run";
      Start_Pipe: statename = "Start_Pipe";
      default   : statename = "XXXXXXXXXX";
    endcase
  end
  `endif

endmodule

